
#pragma once

#include <ostream>
#include <istream>

using namespace std;

class V3 {
public:
	float xyz[3];
	V3() {};
	V3(float x, float y, float z);
	V3 operator+(V3 v1);
	V3 operator-(V3 v1);
	V3 operator/(float x);
	V3 operator*(float x);
	float operator*(V3 v1);
	float& operator[](int i);
	friend ostream& operator<<(ostream& ostr, V3 v);
	V3 operator^(V3 v1);
	V3 UnitVector();
	float Length();
	void SetFromColor(unsigned int col);
	unsigned int GetColor();
	V3 RotateThisPoint(V3 aO, V3 aD, float theta);
	V3 RotateThisVector(V3 aD, float theta);
	V3 Light(V3 matColor, float ka, V3 ld, V3 norm);
};

